using System;
using System.Collections.Generic;
using System.Text;
using SharpNeatLib.NeuralNetwork;

namespace ParaSharpNeatLib
{
    public class EvaluatedNetworkEventArgs
    {
        private INetwork network;
        private double fitness;

        /// <summary>
        /// The fitness of the evaluated network.
        /// </summary>
        public double Fitness
        {
            get { return fitness; }
            set { fitness = value; }
        }
        
        /// <summary>
        /// The network evaluated.
        /// </summary>
        public INetwork Network
        {
            get { return network; }
            set { network = value; }
        }

        public EvaluatedNetworkEventArgs(INetwork network, double fitness)
        {
            this.network = network;
            this.fitness = fitness;
        }
    }
}
